;Colour bars program
;-------------------
;Binary created using DAsm 2.12 running on an Amiga.

   PROCESSOR   6502

   ORG   $C000    ;16Kb PRG-ROM, 8Kb CHR-ROM

Reset_Routine  SUBROUTINE
   cld         ;Clear decimal flag
   sei         ;Disable interrupts
.WaitV   lda $2002
   bpl .WaitV     ;Wait for vertical blanking interval
   ldx #$00
   stx $2000
   stx $2001      ;Screen display off, amongst other things
   dex
   txs         ;Top of stack at $1FF

;Clear (most of) the NES' WRAM. This routine is ripped from "Duck Hunt" - I should probably clear all
;$800 bytes.
   ldy #$06    ;To clear 7 x $100 bytes, from $000 to $6FF?
   sty $01        ;Store count value in $01
   ldy #$00
   sty $00
   lda #$00

.Clear   sta ($00),y    ;Clear $100 bytes
   dey
   bne .Clear

   dec $01        ;Decrement "banks" left counter
   bpl .Clear     ;Do next if >= 0


;********* Initialize Palette to specified colour ********

   ldx   #$3F
   stx   $2006
   ldx   #$00
   stx   $2006

   ldx   #$0D     ;Colour Value (Black)
   ldy   #$20     ;Clear BG & Sprite palettes.
.InitPal stx $2007
   dey
   bne   .InitPal
;*********************************************************

   ldx   #$3F
   stx   $2006
   ldx   #$01
   stx   $2006
   ldx   #$00
   stx   $2007
   ldx   #$10
   stx   $2007
   ldx   #$30
   stx   $2007

;*********************************************************

   ldx   #$20
   stx   $2006
   ldx   #$40
   stx   $2006

   lda   #$10
   sta   $10
   lda   #$00
   ldx   #$00
.DoFullLine   ldy   #$10
.DoGraphicLine   stx   $2007
   inx
   dey
   bne   .DoGraphicLine

   ldy   #$10
.DoBlankLine   sta   $2007
   dey
   bne   .DoBlankLine
   dec   $10
   bne   .DoFullLine

;*******************************************


;Enable vblank interrupts, etc.
   lda   #%10000000
   sta   $2000
   sta   $30
   lda   #$0A        ;Screen on, sprites off, show leftmost 8 pixels, colour
   sta   $2001
;  cli            ;Enable interrupts(?)

;Now just loop forever?
.Loop jmp   .Loop


NMI_Routine SUBROUTINE

   lda   #%00010000
   eor   $30
   sta   $30
   sta   $2000
   lda   #$00
   sta   $2005
   sta   $2005
   rti

IRQ_Routine       ;Dummy label
   rti

;That's all the code. Now we just need to set the vector table approriately.

   ORG   $FFFA,0
   dc.w  NMI_Routine
   dc.w  Reset_Routine
   dc.w  IRQ_Routine    ;Not used, just points to RTI


;The end.
